<?php

/*******************************************
* TornevallNET DNSBL Support for e107 0.7+ *
*                                          *
* Section: Global Module                   *
*                                          *
* thorne@tornevall.net                     *
* Based on http://opm.tornevall.org        *
*                                          *
********************************************/

// Speak to cache here...
global $sql;

// Recommended by pro's!
define(TIMENOW, time());
if (file_exists("language/".e_LANGUAGE.".php")) {include_once("language/".e_LANGUAGE.".php");} else {include_once("language/English.php");}

// Fetch settings for predefined dnsbls here
foreach ($pref as $blP => $blV)
{
	$prefdata = explode("_", $blP);
	if ($prefdata[0] == 'dnsbl')
	{
		$fprefdata = substr($prefdata[1], 0, 1);
		$fsetting = substr($prefdata[1], 1);
		
		if ($fprefdata == 'E' OR $fprefdata == 'N' OR $fprefdata == 'T')
		{
			$dnsbl[$fprefdata][$fsetting] = stripslashes($blV);
		}
		else
		{
			$dnsblpref[$prefdata[1]] = $blV;
		}
	}
}

// Clear resolver from old entries
if ($dnsblpref[cachedelay] < 5) {$dnsblpref[cachedelay] = 5;}	// Spam protection.
$cachedelay = TIMENOW - $dnsblpref[cachedelay]*60;
$sql->db_Delete($dnsblpref[cache], "dateline <= $cachedelay");

// Bitmasks for DNS-based databases starts here
// Observe that njabl and efnet is'nt based on bitmasking
$tornevall = array(
	tornevall_checked => 1,
	tornevall_working => 2,
	tornevall_blitzed => 4,
	tornevall_timeout => 8,
	tornevall_error => 16,
	tornevall_elite => 32,
	tornevall_abuse => 64,
	tornevall_anonymous => 128
);

$njabl = array(
	njabl_relay => 2,
	njabl_dialup => 3,
	njabl_spam => 4,
	njabl_multi => 5,
	njabl_passive => 6,
	njabl_formmail => 8,
	njabl_openproxy => 9
);

$efnet = array(
	efnet_openproxy => 1,
	efnet_spamtrap666 => 2,
	efnet_spamtrap50 => 3,
	efnet_tor => 4,
	efnet_drones => 5
);
// Bitmasks for DNS-based databases stops here


function bitmask ($bit = '')
{
	$loadbits = 8; // Antal bitar att rkna med
	for ($i = 0 ; $i < $loadbits ; ++$i) {$arr[] = pow(2,$i); }     // Automatisera bitvrden
	for ($i = 0 ; $i < count($arr) ; ++$i) {$mask[$i] = ($bit & $arr[$i]) ? '1' : '0';}     // Stt 1 till de bitvrden som r pslagna
	return $mask;
}

function rblresolve ($ip = '', $rbldomain = '')
{
	if (!$ip) {return false;}			// No data should return nothing
	if (!$rbldomain) {return false;}	// No rbl = ignore
	$returnthis = explode('.', gethostbyname(implode('.', array_reverse(explode('.', $ip))) . '.' . $rbldomain));		// Not ipv6-compatible!
	if (implode(".", $returnthis) != implode('.', array_reverse(explode('.', $_SERVER['REMOTE_ADDR']))) . '.' . $rbldomain) {return $returnthis;} else {return false;}
}


// Clear some variables we want to read from... (Just to be a bit more that you - yes, you - are entering domains in our way,
// since this should be an array...)
$dnslist = explode(' ', preg_replace("[,|\s+|\r|\n]", ' ', $dnsblpref['dnslist']));
$excludes = explode(' ', preg_replace("[,|\s+|\r|\n]", ' ', $dnsblpref['exclude']));

// Decide to run the rblchecker here, or not...
foreach ($excludes as $rbl) {if (preg_match("[$rbl]", $_SERVER['REMOTE_ADDR'], $rblm) AND $rbl AND preg_match("[.]", $rbl, $rbl)) {$ignorerbl = true;}}

if ($dnsblpref['active'] AND !$ignorerbl)
{
	$sql->db_Select($dnsblpref[cache], "*", "ip = '".$_SERVER['REMOTE_ADDR']."' LIMIT 1");
	$islisted = $sql->db_Fetch();

	$cache['ip'] = $_SERVER['REMOTE_ADDR'];
	$cache['dateline'] = TIMENOW;

	if (!$islisted['ip'])
	{	
		foreach ($dnslist as $rblname)	// Loop through rbls
		{
			if ($rblname)	// Make sure the resolver won't be empty...
			{
				$response = rblresolve($_SERVER['REMOTE_ADDR'], $rblname);
				if ($response[0] == '127')	// If resolver says positive, start analyze
				{
					$lastbit = $response[3];
					$bits = bitmask($lastbit);
					
					if ($dnsblpref[blockall]) {$doblock = true;}	// Block everything on detection, don't care about any bits

					unset($predefined);

					// Look for pre-defined bitmasking DNSBL's
					if ($rblname == 'opm.tornevall.org') {$dobit = "tornevall";$predefined = true;}

					// Look for pre-defined non-bitmasking DNSBL's
					if ($rblname == 'rbl.efnet.org') {$nobit = "efnet";$predefined = true;}
					if ($rblname == 'dnsbl.njabl.org') {$nobit = "njabl";$predefined = true;}

					if (!$predefined AND $dnsblpref[blockunpre]) {$doblock = true;}		// Block everything on detection if result is coming from non-predefined DNSBL's

					if ($dobit)		// If this is a bitmasking host, check which bits are enabled in e107
					{
						foreach ($bits as $bb => $bv)
						{
							if ($bv)		// If bit is true/on
							{
								foreach ($$dobit as $tc => $tv)		// Check which is matching our active settings and the predefined
								{
									$setting = explode("_", $tc);
									$initvar = strtoupper(substr($dobit,0,1));
									$onoff = $pref["dnsbl_" . $initvar . $setting[1]];
									if ($tv == pow(2, $bb) AND $onoff) {$doblock = true;}
								}
							}
						}
					}
					else			// If this isn't bitmasks, do a regular check
					{
						foreach ($$nobit as $tc => $tv)				// Check which returned value from resolver that match our settings and the predefined
						{
							$setting = explode("_", $tc);
							$initvar = strtoupper(substr($nobit,0,1));
							$onoff = $pref["dnsbl_" . $initvar . $setting[1]];
							if ($onoff AND $response[3] == $tv) {$doblock = true;}
						}
					}
				}		// Ending response 127
			
				// This part is for caching ...
				if ($doblock)
				{
					$cache['listed'] = true;		// Follow e107-rules and cache blockhosts as listed
				}
				else
				{
					$cache['listed'] = false;		// If nothine was resolved, still save this entry to cache
				} // ... and stops here!
			}	// Ending RBL-existence
		}	// Ending RBL-list
	}	// Ending cachecontrol

	// Update or insert cache
	if (!$islisted['ip']) {$sql->db_Insert($dnsblpref[cache], $cache);} else {$sql->db_Update($dnsblpref[cache], "dateline = '".TIMENOW."' WHERE ip = '".$_SERVER['REMOTE_ADDR']."'");}
	if ($islisted['listed'] OR $doblock)
	{
		// This is a special solution since the idiots behind e107 forgot (?) to include
		// easy-to-handle-methods for templates during module-runing... Thanks a lot!
		echo DNSBL_DENY;
		exit;
	}
	
	unset($cache);	// Kill settings sent to cache

}

?>
